unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, DBCtrls, DBGrids,
  StdCtrls, ZConnection, ZDataset, DB;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    ZConnection1: TZConnection;
    ZQuery1: TZQuery;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);

  procedure TableRandomFill;
  var
    i: Integer;
  begin
    for i := 0 to 99 do begin
      ZQuery1.Append;
      ZQuery1.FieldByName('foo').AsString := 'Foo' + IntToStr(i);
      ZQuery1.FieldByName('bar').AsString := 'Bar' + IntToStr(i);
      ZQuery1.FieldByName('bas').AsFloat  := Random(100) / 100;
      ZQuery1.Insert;
    end;
  end;

begin
  ZConnection1.Database := GetCurrentDir + PathDelim + 'test.sql';
  ZConnection1.LibraryLocation := GetCurrentDir + PathDelim + 'sqlite3.dll';
  ZConnection1.Properties.Text := 'Undefined_Varchar_AsString_Length=255';
  ZConnection1.Connected := True;

  ZQuery1.SQL.Text:=
    'CREATE TABLE IF NOT EXISTS test (' +
    'id INTEGER PRIMARY KEY AUTOINCREMENT, ' +
    'foo VARCHAR(100), ' +
    'bar VARCHAR(100), ' +
    'bas REAL);';
  ZQuery1.ExecSQL;

  ZQuery1.SQL.Text:='SELECT * FROM test;';
  ZQuery1.Open;

  if ZQuery1.RecordCount = 0 then
    TableRandomFill;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ZQuery1.SQL.Text := 'SELECT sql FROM "sqlite_schema" WHERE "type"="table" AND "tbl_name"="test"';
//  ZQuery1.SQL.Text := 'SELECT sql FROM sqlite_schema WHERE type = ''table'' AND tbl_name=''test''';
  ZQuery1.Open;
end;

end.

